#==============================================================================
#  Window_Target_Enemy
#------------------------------------------------------------------------------
# ^[QbgGl~[EBhE
# Copyright (C) 2005 fukuyama
#==============================================================================

module DQ
  module Battle
    
    class Window_Target_Enemy < ::DQ::Battle::Window_Page_Menu
      include Window_Tree_Module
      
      def target_enemies
        enemies = []
        name = get_menu
        if not group?
          # C̏ꍇ
          enemies.push @arrows[@arrows_index].enemy
        else
          group_arrows = @enemies_arrow[name]
          # O[v̏ꍇ
          for arrow in group_arrows
            enemies.push arrow.enemy
          end
        end
        return enemies
      end
      
      def group?
        return @group_target
      end
      
      #--------------------------------------------------------------------------
      # 
      #--------------------------------------------------------------------------
      def initialize(parent,group_target = false)
        # Gl~[
        @enemies_count = {}
        @enemies_arrow = {}
        @arrows = []
        @arrows_index = 0
        @group_target = group_target
        
        # Gl~[O擾
        names = []
        for enemy in $game_troop.enemies.sort {|a,b| a.screen_x <=> b.screen_x}
          next if not enemy.exist?
          names.push enemy.name
          if @enemies_count[enemy.name].nil?
            @enemies_count[enemy.name] = 0
            @enemies_arrow[enemy.name] = []
          end
          @enemies_count[enemy.name] += 1
          arrow = Arrow_Enemy.new($scene.spriteset.viewport1,enemy)
          @enemies_arrow[enemy.name].push arrow
          @arrows.push arrow
        end
        
        # Gl~[j[Nɍi
        for name in names.uniq
          add_menu(name, :select_target_enemy)
        end
        
        @index = 0
        @column_max = 1
        
        super(parent)
        
        # EBhEʒu
        window_actor_command = get_window(Window_Actor_Command)
        self.left = window_actor_command.right
        self.top = window_actor_command.top
        
        refresh_arrows
      end
      #--------------------------------------------------------------------------
      # j
      #--------------------------------------------------------------------------
      def dispose
        dispose_arrows
        super
      end
      
      def index=(i)
        super(i)
        if i == menu_size - 1
          @arrows_index = @arrows.index @enemies_arrow[get_menu].last
          refresh_arrows
        end
      end
      
      #--------------------------------------------------------------------------
      # Cxgnh
      #--------------------------------------------------------------------------
      def input_up
        super
        group_arrows = @enemies_arrow[get_menu]
        @arrows_index = @arrows.index group_arrows.last
        refresh_arrows
      end
      def input_down
        super
        group_arrows = @enemies_arrow[get_menu]
        @arrows_index = @arrows.index group_arrows.first
        refresh_arrows
      end
      def input_left
        if @arrows_index <= 0
          select_target_change
          return
        end
        cursor_se
        @arrows_index -= 1
        refresh_arrows
        select_menu(@arrows[@arrows_index].enemy.name)
      end
      def input_right
        if @arrows_index >= (@arrows.size - 1)
          select_target_change
          return
        end
        cursor_se
        @arrows_index += 1
        refresh_arrows
        select_menu(@arrows[@arrows_index].enemy.name)
      end
      def input_b
        if event_handling_trigger?
          @index = -1
          cancel_se
          dispose
        end
      end
      def select_target_change(last_select=false)
        cursor_se
        parent.target_actor(last_select)
        dispose
      end
      def select_target_enemy
        window = get_window(Window_Actor_Command)
        window.targets = self.target_enemies
        top_window.dispose
      end
      
      #---------------------------------------------------------------------------
      # A[J[\ύX
      #---------------------------------------------------------------------------
      def refresh_arrows
        for arrow in @arrows
          arrow.visible = false
        end
        if not group?
          # C̏ꍇ
          if @arrows_index < 0
            @arrows_index = @arrows.size - 1
          end
          if @arrows.size <= @arrows_index
            @arrows_index = 0
          end
          @arrows[@arrows_index].visible = true
        else
          # O[v̏ꍇ
          for arrow in @enemies_arrow[get_menu]
            arrow.visible = true
          end
        end
      end
      #---------------------------------------------------------------------------
      # A[J[\XV
      #---------------------------------------------------------------------------
      def update_arrows
        for arrow in @arrows
          arrow.update
        end
      end
      #---------------------------------------------------------------------------
      # A[J[\j
      #---------------------------------------------------------------------------
      def dispose_arrows
        for arrow in @arrows
          arrow.dispose
        end
      end
      
      #---------------------------------------------------------------------------
      # XV
      #---------------------------------------------------------------------------
      def update
        update_arrows
        super
      end
      
      #--------------------------------------------------------------------------
      # ڂ̕`
      #--------------------------------------------------------------------------
      def draw_menu_item(index,color,rect,name)
        self.contents.font.color = color
        self.contents.fill_rect(rect, Color.new(0, 0, 0, 0))
        self.contents.draw_text(rect, name,0)
        count = "#{@enemies_count[name]} C"
        self.contents.draw_text(rect, count,2)
      end
      
      #---------------------------------------------------------------------------
      # Rec̍쐬
      #  def _contents_height
      #    return _menu_height * 4
      #  end
      #---------------------------------------------------------------------------
      # Rec̍쐬
      def _contents_width
        return _menu_width
      end
      #---------------------------------------------------------------------------
      # j[̍쐬
      def _menu_width
        return BATTLE_WINDOW_TARGET_ENEMY_WIDTH
      end
    end
    
  end
end
