#==============================================================================
#  Window_Skill
#------------------------------------------------------------------------------
# XLEBhE
# Copyright (C) 2005 fukuyama
#==============================================================================

module DQ
  
  class Window_Skill < ::DQ::Window_Page_Menu
    include Window_Tree_Module
    include Menu_Log_Skill_Module
    #--------------------------------------------------------------------------
    # 
    #--------------------------------------------------------------------------
    def initialize(parent,help=true)
      super(parent)
      # ʒu̐ݒ
      self.top  = top_window.top
      self.left = parent.right
      
      if help
        # XLwvEBhE쐬
        x = self.x + self.width
        y = Markup_New_Line.line_height * 2 + 32 + 16
        w = 640 - x - 16
        h = Markup_New_Line.line_height * 8 + 32
        @window_help = Window_Markup_Text.new(x,y,w,h)
        @window_help.back_opacity = WINDOW_BACK_OPACITY
        
        # qEBhEɒǉ
        add_child @window_help
        @window_help.visible = false
        add_input_handler(Input::UP,:change_skill)
        add_input_handler(Input::DOWN,:change_skill)
      end
    end
    #--------------------------------------------------------------------------
    # XV
    #--------------------------------------------------------------------------
    def refresh
      self.clear
      @actor = self.parent.actor
      if not @actor.nil?
        skills = Skill_Facade.actor_normal_skills @actor
        skills.each do |skill|
          add_menu(skill, :select_skill)
        end
      end
      refresh_help
      super
    end
    def refresh_help
      if (not @window_help.nil?) and (not @window_help.disposed?)
        if (not self.skill.nil?) and (not @actor.nil?)
          text = self.skill.description.dup
          text << "\\bottom\\C[n]\\right[#{skill.sp_cost}]#{skill.sp_cost}"
          @window_help.set_text text
        else
          @window_help.set_text ''
        end
      end
    end
    #--------------------------------------------------------------------------
    # XLEBhEĕ`
    #--------------------------------------------------------------------------
    def active_event
      if (not @window_help.nil?) and (not @window_help.disposed?)
        if self.active
          @window_help.visible = true
          refresh_help
        end
      end
    end
    #--------------------------------------------------------------------------
    # XL̎擾
    #--------------------------------------------------------------------------
    def skill
      return get_menu
    end
    #--------------------------------------------------------------------------
    # XLύX
    #--------------------------------------------------------------------------
    def change_skill
      if @index >= 0
        refresh_help
      end
    end
    #--------------------------------------------------------------------------
    # XLI
    #--------------------------------------------------------------------------
    def select_skill
      actor = get_window(Window_Actor_Menu_Skill).actor
      skill = self.skill
      # gpłȂꍇ
      if skill == nil or not actor.skill_can_use?(skill.id)
        # SP Ȃꍇ͎gps
        if skill.sp_cost > actor.sp
          menu_log_use_skill_sp_cost_error(skill,actor)
          return
        end
        # 퓬s\̏ꍇ͎gps
        if actor.dead?
          menu_log_use_skill_actor_state_error(skill,actor)
          return
        end
        # ُԂ̏ꍇAXLȊO͎gps
        if skill.atk_f == 0 and actor.restriction == 1
          menu_log_use_skill_actor_state_error(skill,actor)
          return
        end
        return
      end
      #  SE t
      $game_system.se_play($data_system.decision_se)
      # ʔ͈͂P̂̏ꍇ
      if skill.scope == 3 or skill.scope == 5
        window = Window_Actor_Menu_Skill_Use.new(self)
        set_active_window(window.class)
        return
      end
      targets = []
      # ʔ͈͂Ŝ̏ꍇ
      if skill.scope == 4
        targets = $game_party.actors
      end
      # ʔ͈͂S(hp0)̏ꍇ
      if skill.scope == 6
        $game_party.actors.each do |actor|
          targets.push actor if actor.hp0?
        end
      end
      # XLgp
      used = Skill_Facade.use_skill(skill,actor,targets)
      # XLgꍇ
      if used
        menu_log_use_skill(skill,actor,targets)
        @message_end = true
      end
    end
    #--------------------------------------------------------------------------
    # LZ
    #--------------------------------------------------------------------------
    def input_b
      cancel_se
      self.index = -1
      @window_help.visible = false
      set_active_window(Window_Actor_Menu_Skill)
    end
    #--------------------------------------------------------------------------
    # ڂ̕`
    #--------------------------------------------------------------------------
    def draw_menu_item(index,color,rect,skill)
      self.contents.font.color = color
      self.contents.fill_rect(rect, Color.new(0, 0, 0, 0))
      self.contents.draw_text(rect, skill.name)
    end
    #---------------------------------------------------------------------------
    # Rec̍쐬
    def _contents_width
      return _menu_width * 1
    end
    #---------------------------------------------------------------------------
    # Rec̍쐬
    def _contents_height
      return _menu_height * 12
    end
    #---------------------------------------------------------------------------
    # j[̍쐬
    def _menu_height
      return super
    end
    #---------------------------------------------------------------------------
    # j[̍쐬
    def _menu_width
      return WINDOW_SKILL_WIDTH
    end
  end
  
end
